import psycopg2

#Параметры 
host_ = "localhost"
port_ = 5432
user_ = "postgres"
password_ = "<YOUR PAS>" 
database_="postgres"

def create_database():
    try:
        connection = psycopg2.connect(
        host=host_,
        port=port_,
        user=user_,
        password=password_,
        database=database_
        )
    except (Exception, psycopg2.Error) as error:
        print("Can't connect to DB: ", error)
        return
    
    with connection.cursor() as cursor:
        cursor.execute(""" 
                    CREATE TABLE IF NOT EXISTS my_users( 
    nick_name VARCHAR(255) NOT NULL PRIMARY KEY, 
    first_name VARCHAR(255) NOT NULL, 
    last_name VARCHAR(255) NOT NULL, 
    password_user VARCHAR(255) NOT NULL 
    ); 
                     """)
        connection.commit()
    print('[SERVER] table created!')
    connection.close()
    

def insert_into_users(nick_name, first_name, last_name, password_user):
    try:
        connection = psycopg2.connect(
        host=host_,
        port=port_,
        user=user_,
        password=password_,
        database=database_
        )
    except (Exception, psycopg2.Error) as error:
        print("Can't connect to DB: ", error)
    
    with connection.cursor() as cursor:
        cursor.execute(""" 
                    INSERT INTO my_users 
                    VALUES (%s, %s, %s, %s); """,
                           (nick_name, first_name, last_name, password_user))
        connection.commit()
    connection.close()

def checking_uniqueness(nick_name):
    try:
        connection = psycopg2.connect(
        host="195.19.32.74",
        port=port_,
        user=user_,
        password=password_,   
        database=database_
        )
    except (Exception, psycopg2.Error) as error:
        print("Can't connect to DB: ", error)
    with connection.cursor() as cursor:
        cursor.execute(f""" 
                SELECT 1 FROM my_users WHERE nick_name = '{nick_name}' """)

        res_= cursor.fetchone()
        connection.close()
        return res_
    

def user_verification(nick_name, password_user):
    print(nick_name, password_user)
    try:
        connection = psycopg2.connect(
        host="195.19.32.74",
        port=port_,
        user=user_,
        password=password_,
        database=database_
        )
    except (Exception, psycopg2.Error) as error:
        print("Can't connect to DB: ", error)
    with connection.cursor() as cursor:
        try:
            cursor.execute(f""" 
                SELECT 1 FROM my_users WHERE nick_name = '{nick_name}' AND  password_user = '{password_user}' """
                )
            res_ = cursor.fetchone()
            connection.close()
            return res_
        except (Exception, psycopg2.Error) as error:
            print("Can't select from database:", error)
        
    
